#include <iostream>
#include <cmath>

using namespace std;

#define ASSERT(test) if (!(test)) cout << "Test failed in file " << __FILE__ \
				       << " line " << __LINE__ << ": " #test << endl


const double epsilon = 1e-6;

/** teste si deux nombres sont egaux à epsilon près
* @param[in] x et y deux nombres réels
* @return le booléan correspondant au test
**/
bool presqueEgal(double x, double y) {
    if ((fabs(x-y) <= epsilon*fabs(x)) and (fabs(x-y) <= epsilon*fabs(y))) {
        return true;
    }
    return false;
}



struct Complexe {
    float re, im;
};


Complexe creeComplexe(float reel, float imaginaire){
    Complexe c;
    c.re = reel;
    c.im = imaginaire;
    return c;
    // On peut aussi écrire
    // return {reel, imaginaire};
}

bool egalComplexe(Complexe c1, Complexe c2){
    return (c1.re == c2.re) && (c1.im == c2.im);
}
bool presqueEgalComplexe(Complexe c1, Complexe c2){
    return presqueEgal(c1.re, c2.re) && presqueEgal(c1.im, c2.im);
}

Complexe ajouterComplexe(Complexe c1, Complexe c2){
    Complexe resultat;
    resultat.re = c1.re + c2.re;
    resultat.im = c1.im + c2.im;
    return resultat;
}

Complexe multiplierComplexe(Complexe c1, Complexe c2){
     /*A remplir*/
}

void testMultiplierComplexe(){
    /*A remplir*/
}

float moduleComplexe(Complexe c){
    /*A remplir*/
}

bool znResteBorne(Complexe c){
    /*A remplir*/
}

void mandelbrot(){
    const float xmin = -2;
    const float xmax = 0.5;
    const float ymin = -1.5;
    const float ymax = 1.5;
    const int resol = 79;
    for(int i=0; i<=resol; i++) {
        for(int j=0; j<=resol; j++) {
            if(znResteBorne(creeComplexe((resol-j)*xmin/resol+j*xmax/resol,
                                         (resol-i)*ymax/resol+i*ymin/resol))) {
                    cout << '#';
            }
            else {
                    cout << ' ';
            }
        }
        cout << endl;
    }
}

int main(){

    return 0;
}
